; punctuation 1-2, jascii
alias euc2txt {
  unset %euc.e
  :loop
  if $left(%euc.j,1) ==  { 01.dec }
  elseif $left(%euc.j,1) ==  { 02.dec }
  elseif $left(%euc.j,1) ==  { 03.dec }
  elseif $left(%euc.j,1) ==  { 04.dec }
  elseif $left(%euc.j,1) ==  { 05.dec }
  elseif $asc($left(%euc.j,1)) isnum 176-244  { kanjidec $left(%euc.j,1) }
  ;
  elseif $left(%euc.j,1) == $chr(32) || $left(%euc.j,1) == $chr(160) {
    set %euc.e %euc.e $+ $chr(160)
    if $len(%euc.j) < 1 { return }
    set %euc.j $right(%euc.j,$calc( $len(%euc.j) - 1 ))
  }
  elseif $len(%euc.j) < 1 { return }
  else {
    ; echo -s Error decoding japanese - unmapped kanji
    set %euc.e %euc.e $+ 
    if $len(%euc.j) < 1 { return }
    set %euc.j $right(%euc.j,$calc( $len(%euc.j) - 2 ))
    goto loop
  }
  ;
  :end
  if $result isnum {
    if $len(%euc.j) < 1 { return }
    set %euc.j $right(%euc.j,$calc( $len(%euc.j) - $result ))
  }
  elseif $result == error {
    echo -s Error decoding Japanese - unmapped character 
    if $len(%euc.j) < 1 { return }
    set %euc.j $right(%euc.j,$calc( $len(%euc.j) - 2 ))
  }
  goto loop
}
;
;
;
alias kanjidec {
  set %dic D:\programs\mirc\rhialto\nihongo\mircdict.csv
  set %l 1
  :loop
  ;echo . %l
  if %l > $lines(%dic) {
    set %euc.e %euc.e $+ [?]
    return 2
  }
  if $left(%euc.j,$csv(%dic,%l,3)) == $left($csv(%dic,%l,1),$csv(%dic,%l,3)) {
    set %euc.e %euc.e $+ $csv(%dic,%l,2)
    return $csv(%dic,%l,3)
  }
  ;
  if $left(%euc.j,2) == $left($csv(%dic,%l,1),2) {
    if $left(%euc.j,4) == $left($csv(%dic,%l,1),4) {
      if $left(%euc.j,4) == $left($csv(%dic,%l,1),6) {
        if $left(%euc.j,4) == $left($csv(%dic,%l,1),8) {
          if $left(%euc.j,4) == $left($csv(%dic,%l,1),10) {
            if $calc( %l + $csv(%dic,%l,9) ) >= $lines(%dic) { goto end }
            else { inc %l $csv(%dic,%l,9) | goto loop }
          }
          if $calc( %l + $csv(%dic,%l,8) ) >= $lines(%dic) { goto end }
          else { inc %l $csv(%dic,%l,8) | goto loop }
        }
        if $calc( %l + $csv(%dic,%l,7) ) >= $lines(%dic) { goto end }
        else { inc %l $csv(%dic,%l,7) | goto loop }
      }
      if $calc( %l + $csv(%dic,%l,6) ) >= $lines(%dic) { goto end }
      else { inc %l $csv(%dic,%l,6) | goto loop }
    }
    if $calc( %l + 1 ) >= $lines(%dic) { goto end }
    else { inc %l 1 | goto loop }
  }
  if $calc( %l + $csv(%dic,%l,5) ) >= $lines(%dic) { goto end }
  else { inc %l $csv(%dic,%l,5) | goto loop }
  ;
  :end
  set %euc.e %euc.e $+ [?]
  return 2
}
;
; $csv(file,row,column)
;
alias csv {
  set %csv $read -nl $+ $2 $1
  return $gettok(%csv,$3,44)
}
alias 01.dec {
  ; jis table page 1
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ $chr(160) | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ , | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ . | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ , | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ . | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ . | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ : | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ ; | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ ? | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ ! | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ " | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ . | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ ^ | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ ^ | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ " | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ ^ | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+  | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ _ | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+  | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+  | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+  | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+  | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+  | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+  | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+  | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+  | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ 0 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ - | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ -- | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ - | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ / | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ \ | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ ~ | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ $chr(124) $+ $chr(124) | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ $chr(124) | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ ... | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ .. | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ ' | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ ' | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ " | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ " | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ ( | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ ) | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ $chr(91) | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ $chr(93) | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ $chr(91) | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ $chr(93) | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ $chr(123) | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ $chr(125) | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ < | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ > | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ << | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ >> | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ ' | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ ' | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ " | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ " | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ ( | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ ) | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ + | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ - | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ +/- | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ x | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ / | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ = | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ != | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ < | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ > | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ <= | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ => | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+  | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+  | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ [M] | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ [F] | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+  | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ ' | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ " | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ C | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ [YEN] | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ $chr(36) | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ c | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ [GBP] | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ % | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ $chr(35) | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ & | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ * | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ $chr(64) | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+  | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ * | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ * | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ O | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ O | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ O | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+  | return 2 }
  set %euc.e %euc.e $+ 
  return error
}
alias 02.dec {
  ; jis table page 2
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+  | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+  | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+  | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+  | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+  | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+  | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+  | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+  | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ T | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ -> | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ <- | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ /|\ | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ \|/ | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ = | return 2 }
  ; musical note character not supported in JWP
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ ' | return 2 }
  set %euc.e %euc.e $+ 
  return error
}
;
alias 03.dec {
  ; jis table page 3
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ a2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ b2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ c2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ d2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ e2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ f2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ g2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ h2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ i2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ j2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ k2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ l2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ m2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ n2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ o2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ p2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ q2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ r2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ s2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ t2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ u2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ v2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ w2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ x2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ y2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ z2,15 | return 2 }
  ; uppercase jascii
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ A2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ B2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ C2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ D2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ E2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ F2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ G2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ H2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ I2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ J2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ K2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ L2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ M2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ N2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ O2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ P2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ Q2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ R2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ S2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ T2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ U2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ V2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ W2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ X2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ Y2,15 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ Z2,15 | return 2 }
  ; numerals
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ 1 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ 2 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ 3 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ 4 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ 5 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ 6 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ 7 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ 8 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ 9 | return 2 }
  if $left(%euc.j,2) ==  { set %euc.e %euc.e $+ 0 | return 2 }
  set %euc.e %euc.e $+ 
  return error
}
